package nl.naturalis.oaipmh.api;

import java.io.InputStream;
import java.io.OutputStream;

/**
 * <p>
 * Specifies the capacities of an OAI repository. This is a callback and lifecycle
 * interface with specific methods being called at specific events by the OAIPMH server.
 * Note that implementing this interface is not enough to run inside the OAIPMH server.
 * Only implementations of {@link StandAloneRepository} can run in the OAIPMH server.
 * </p>
 * <h3>Note about XML namespace prefixes</h3>
 * <p>
 * When you are using a custom XML schema inside the OAI-PMH skeleton, you will probably
 * want to use your own namespace prefixes rather than the non-descript prefixes generated
 * by JAXB ("ns1", "ns2", etc.). This version of the API does not provide you with the
 * means to do that programmatically. Thefore, you must update the package-info.java file
 * in your JAXB package. Include an {@code xmlns} attribute within the {@code XmlSchema}
 * annotation that you see in the package-info.java file generated by xjc. Note that you
 * must do this each time you generate your JAXB classes using xjc since this will also
 * overwrite the package-info.java file! Example:
 * </p>
 *
 * <pre>
 * xmlns=&#64;XmlNs(namespaceURI=&#34;http://example.com/some&#34;,prefix=&#34;xyz&#34;)
 *
 * <pre>
 * * @author Ayco Holleman
 */
public interface OaiRepository {

  /**
   * Returns the {@link ResumptionTokenParser} to must be used by the OAIPMH server in
   * order to decompose a resumption token into its constituent parts.
   *
   * @return
   */
  ResumptionTokenParser getResumptionTokenParser();

  /**
   * Return an {@link InputStream} from which to read the XML schema definition
   * corresponding to the specified metadata prefix. This is meant to inform clients about
   * the XML schemas used within the &lt;oai_dc&gt; element of the OAI-PMH output. The
   * default implementation throws an {@link XsdNotFoundException}.
   *
   * @param metadataPrefix
   * @return
   * @throws RepositoryException
   */
  InputStream getXsdForMetadataPrefix(String metadataPrefix) throws RepositoryException;

  /**
   * Prepare and initialize for a new OAI-PMH request.
   *
   * @param request
   */
  void newRequest(OaiRequest request);

  /**
   * Implement the GetRecord protocol request. The resulting OAI-PMH should be written to
   * the specified output stream. Repository implementations that have no use for this
   * method should implement it by throwing a {@link UnsupportedOperationException}. This
   * will be translated by the oaipmh server into a 501 (Not Implemented) HTTP response.
   *
   * @param output
   * @throws OaiProtocolException
   * @throws RepositoryException
   * @throws UnsupportedOperationException
   */
  void getRecord(OutputStream output)
        throws OaiProtocolException, RepositoryException, UnsupportedOperationException;

  /**
   * Implement the ListRecords protocol request. The resulting OAI-PMH should be written
   * to the specified output stream. Implement the GetRecord protocol request. The
   * resulting OAI-PMH should be written to the specified output stream. Repository
   * implementations that have no use for this method should implement it by throwing a
   * {@link UnsupportedOperationException}. This will be translated by the oaipmh server
   * into a 501 (Not Implemented) HTTP response.
   *
   * @param output
   * @throws OaiProtocolException
   * @throws RepositoryException
   * @throws UnsupportedOperationException
   */
  void listRecords(OutputStream output)
        throws OaiProtocolException, RepositoryException, UnsupportedOperationException;

  /**
   * Implement the GetRecord protocol request. The resulting OAI-PMH should be written to
   * the specified output stream. Implement the GetRecord protocol request. The resulting
   * OAI-PMH should be written to the specified output stream. Repository implementations
   * that have no use for this method should implement it by throwing a
   * {@link UnsupportedOperationException}. This will be translated by the oaipmh server
   * into a 501 (Not Implemented) HTTP response.
   *
   * @param output
   * @throws OaiProtocolExceptionf
   * @throws RepositoryException
   * @throws UnsupportedOperationException
   */
  void listIdentifiers(OutputStream output)
        throws OaiProtocolException, RepositoryException, UnsupportedOperationException;

  /**
   * Implement the ListMetaDataFormats protocol request. The resulting OAI-PMH should be
   * written to the specified output stream. Implement the GetRecord protocol request. The
   * resulting OAI-PMH should be written to the specified output stream. Repository
   * implementations that have no use for this method should implement it by throwing a
   * {@link UnsupportedOperationException}. This will be translated by the oaipmh server
   * into a 501 (Not Implemented) HTTP response.
   *
   * @param output
   * @throws OaiProtocolException
   * @throws RepositoryException
   * @throws UnsupportedOperationException
   */
  void listMetaDataFormats(OutputStream output)
        throws OaiProtocolException, RepositoryException, UnsupportedOperationException;

  /**
   * Implement the ListSets protocol request. The resulting OAI-PMH should be written to
   * the specified output stream. Implement the GetRecord protocol request. The resulting
   * OAI-PMH should be written to the specified output stream. Repository implementations
   * that have no use for this method should implement it by throwing a
   * {@link UnsupportedOperationException}. This will be translated by the oaipmh server
   * into a 501 (Not Implemented) HTTP response.
   *
   * @param output
   * @throws OaiProtocolException
   * @throws RepositoryException
   * @throws UnsupportedOperationException
   */
  void listSets(OutputStream output)
        throws OaiProtocolException, RepositoryException, UnsupportedOperationException;

  /**
   * Implement the Identify protocol request. The resulting OAI-PMH should be written to
   * the specified output stream. Implement the GetRecord protocol request. The resulting
   * OAI-PMH should be written to the specified output stream. Repository implementations
   * that have no use for this method should implement it by throwing a
   * {@link UnsupportedOperationException}. This will be translated by the oaipmh server
   * into a 501 (Not Implemented) HTTP response.
   *
   * @param output
   * @throws OaiProtocolException
   * @throws RepositoryException
   * @throws UnsupportedOperationException
   */
  void identify(OutputStream output)
        throws OaiProtocolException, RepositoryException, UnsupportedOperationException;

}
